var webviewJs = {};
webviewJs.os = {};
webviewJs.os.isIOS = /iOS|iPhone|iPad|iPod/i.test(navigator.userAgent);
webviewJs.os.isAndroid = !webviewJs.os.isIOS;
webviewJs.callbacks = {}

webviewJs.callback = function (callbackname, response) {
   var callbackobject = webviewJs.callbacks[callbackname];
   console.log("xxxx"+callbackname);
   if (callbackobject !== undefined){
       if(callbackobject.callback != undefined){
          console.log("xxxxxx"+response);
            var ret = callbackobject.callback(response);
           if(ret === false){
               return
           }
           delete webviewJs.callbacks[callbackname];
       }
   }
}

webviewJs.takeNativeAction = function(commandname, parameters){
    console.log("webviewJs takenativeaction")
    var request = {};
    request.name = commandname;
    request.param = parameters;
    if(window.webviewJs.os.isAndroid){
        console.log("android take native action" + JSON.stringify(request));
        window.webviewJsInterface.takeNativeAction(JSON.stringify(request));
    } else {
        window.webkit.messageHandlers.webviewJsInterface.postMessage(JSON.stringify(request))
    }
}

webviewJs.takeNativeActionWithCallback = function(commandname, parameters, callback) {
    var callbackname = "nativetojs_callback_" +  (new Date()).getTime() + "_" + Math.floor(Math.random() * 10000);
    webviewJs.callbacks[callbackname] = {callback:callback};

    var request = {};
    request.name = commandname;
    request.param = parameters;
    request.param.callbackname = callbackname;
    if(window.webviewJs.os.isAndroid){
        window.webviewJsInterface.takeNativeAction(JSON.stringify(request));
    } else {
        window.webkit.messageHandlers.webviewJsInterface.postMessage(JSON.stringify(request))
    }
}

window.webviewJs = webviewJs;
